package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;
import io.github.jhipster.service.filter.InstantFilter;

/**
 * Criteria class for the TBObjectParameter entity. This class is used in TBObjectParameterResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-object-parameters?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBObjectParameterCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private StringFilter name;

    private StringFilter unit;

    private StringFilter description;

    private StringFilter groupName;

    private InstantFilter createdDate;

    private InstantFilter modifiedDate;

    private InstantFilter deletedDate;

    private LongFilter deletedById;

    private LongFilter createdById;

    private LongFilter modifiedById;

    private LongFilter activityTypeId;

    private LongFilter tbControlTypeId;

    private LongFilter tbActivityExtendTypeId;

    private BooleanFilter isGuidelineUsing;

    private BooleanFilter isMandatory;

    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public StringFilter getName() {
        return name;
    }

    public void setName(StringFilter name) {
        this.name = name;
    }

    public StringFilter getUnit() {
        return unit;
    }

    public void setUnit(StringFilter unit) {
        this.unit = unit;
    }

    public StringFilter getDescription() {
        return description;
    }

    public void setDescription(StringFilter description) {
        this.description = description;
    }

    public InstantFilter getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(InstantFilter createdDate) {
        this.createdDate = createdDate;
    }

    public InstantFilter getModifiedDate() {
        return modifiedDate;
    }

    public void setModifiedDate(InstantFilter modifiedDate) {
        this.modifiedDate = modifiedDate;
    }

    public InstantFilter getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(InstantFilter deletedDate) {
        this.deletedDate = deletedDate;
    }

    public LongFilter getDeletedById() {
        return deletedById;
    }

    public void setDeletedById(LongFilter deletedById) {
        this.deletedById = deletedById;
    }

    public LongFilter getCreatedById() {
        return createdById;
    }

    public void setCreatedById(LongFilter createdById) {
        this.createdById = createdById;
    }

    public LongFilter getModifiedById() {
        return modifiedById;
    }

    public void setModifiedById(LongFilter modifiedById) {
        this.modifiedById = modifiedById;
    }

    public LongFilter getActivityTypeId() {
        return activityTypeId;
    }

    public void setActivityTypeId(LongFilter activityTypeId) {
        this.activityTypeId = activityTypeId;
    }

    public LongFilter getTbControlTypeId() {
        return tbControlTypeId;
    }

    public void setTbControlTypeId(LongFilter tbControlTypeId) {
        this.tbControlTypeId = tbControlTypeId;
    }

    public LongFilter getTbActivityExtendTypeId() {
        return tbActivityExtendTypeId;
    }

    public void setTbActivityExtendTypeId(LongFilter tbActivityExtendTypeId) {
        this.tbActivityExtendTypeId = tbActivityExtendTypeId;
    }

    public BooleanFilter getIsGuidelineUsing() {
        return isGuidelineUsing;
    }

    public void setIsGuidelineUsing(BooleanFilter isGuidelineUsing) {
        this.isGuidelineUsing = isGuidelineUsing;
    }

    public BooleanFilter getIsMandatory() {
        return isMandatory;
    }

    public void setIsMandatory(BooleanFilter isMandatory) {
        this.isMandatory = isMandatory;
    }

    public StringFilter getGroupName() {
        return groupName;
    }

    public void setGroupName(StringFilter groupName) {
        this.groupName = groupName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBObjectParameterCriteria that = (TBObjectParameterCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(name, that.name) &&
            Objects.equals(unit, that.unit) &&
            Objects.equals(description, that.description) &&
            Objects.equals(createdDate, that.createdDate) &&
            Objects.equals(modifiedDate, that.modifiedDate) &&
            Objects.equals(deletedDate, that.deletedDate) &&
            Objects.equals(deletedById, that.deletedById) &&
            Objects.equals(createdById, that.createdById) &&
            Objects.equals(modifiedById, that.modifiedById) &&
            Objects.equals(activityTypeId, that.activityTypeId) &&
            Objects.equals(tbActivityExtendTypeId, that.tbActivityExtendTypeId) &&
            Objects.equals(tbControlTypeId, that.tbControlTypeId) &&
            Objects.equals(isGuidelineUsing, that.isGuidelineUsing) &&
            Objects.equals(isMandatory, that.isMandatory) &&
            Objects.equals(groupName, that.groupName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        name,
        unit,
        description,
        createdDate,
        modifiedDate,
        deletedDate,
        deletedById,
        createdById,
        modifiedById,
        activityTypeId,
        isGuidelineUsing,
        isMandatory,
        tbActivityExtendTypeId,
        tbControlTypeId,
        groupName
        );
    }

    @Override
    public String toString() {
        return "TBObjectParameterCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (name != null ? "name=" + name + ", " : "") +
                (unit != null ? "unit=" + unit + ", " : "") +
                (description != null ? "description=" + description + ", " : "") +
                (createdDate != null ? "createdDate=" + createdDate + ", " : "") +
                (modifiedDate != null ? "modifiedDate=" + modifiedDate + ", " : "") +
                (deletedDate != null ? "deletedDate=" + deletedDate + ", " : "") +
                (deletedById != null ? "deletedById=" + deletedById + ", " : "") +
                (createdById != null ? "createdById=" + createdById + ", " : "") +
                (modifiedById != null ? "modifiedById=" + modifiedById + ", " : "") +
                (activityTypeId != null ? "activityTypeId=" + activityTypeId + ", " : "") +
                (tbControlTypeId != null ? "tbControlTypeId=" + tbControlTypeId + ", " : "") +
                (tbActivityExtendTypeId != null ? "tbActivityExtendTypeId=" + tbActivityExtendTypeId + ", " : "") +
                (isGuidelineUsing != null ? "isGuidelineUsing=" + isGuidelineUsing + ", " : "") +
                (isMandatory != null ? "isMandatory=" + isMandatory + ", " : "") +
                (groupName != null ? "groupName=" + groupName + ", " : "") +
            "}";
    }
}
